// ._______________________________________________________.
// | .___  .   .   __     .   . .____    .   .   _   _____ |
// | |   \ |   |  /  \    |\ /| |        |\  |  / \    |   |
// | |___/ |   | {  _  __ | v | |__   __ | \ | {   }   |   |
// | |   \ {   } {   \    |   | |        |  \| {   }   |   |
// | |___/  \_/   \__/    |   | |____    |   |  \_/    |   |
// |_______________________________________________________|
// |                                                       |
// |  Build 1.0.4        Scripted by Xalos (BL_ID: 11239)  |
// |_______________________________________________________|



// .___________________.
// |   __  .   . _____ |
// |  /  \ |   |   |   |
// | {  _  |   |   |   |
// | {   \ {   }   |   |
// |  \__/  \_/  __|__ |
// |___________________|

new GuiControl(BugMeNotGUI)
{
	visible = 0;
	
	new GuiWindowCtrl(BugMeNotWindow)
	{
		position = "250 100";
		extent = "300 400";
		
		closeCommand = "Canvas.popDialog(BugMeNotGUI);";
		command = "Canvas.popDialog(BugMeNotGUI);";
		accelerator = "Escape";
		
		text = "Bug-Me-Not";
		
		canMinimize = 0;
		canMaximize = 0;
		resizeHeight = 0;
		resizeWidth = 0;
		
		new GuiPopupMenuCtrl(BMN_BuildTrustAction)
		{
			position = "20 36";
			extent = "40 20";
			
			command = "BMN_updateAction(\"Build\");";
		};
		
		new GuiTextCtrl()
		{
			position = "64 36";
			extent = "50 20";
			
			text = "Build Trust Invites";
		};
		
		new GuiPopupMenuCtrl(BMN_FullTrustAction)
		{
			position = "20 60";
			extent = "40 20";
			
			command = "BMN_updateAction(\"Full\");";
		};
		
		new GuiTextCtrl()
		{
			position = "64 60";
			extent = "50 20";
			
			text = "Full Trust Invites";
		};
		
		new GuiPopupMenuCtrl(BMN_MinigameAction)
		{
			position = "20 84";
			extent = "40 20";
			
			command = "BMN_updateAction(\"Minigame\");";
		};
		
		new GuiTextCtrl()
		{
			position = "64 84";
			extent = "50 20";
			
			text = "Minigame Invites";
		};
		
		new GuiSwatchCtrl()
		{
			position = "16 108";
			extent = "144 2";
			
			color = "0 0 0 128";
		};
		
		new GuiBitmapButtonCtrl(BMN_IgnoreButton)   //I wanted it to look like the drop-downs.
		{
			position = "20 114";
			extent = "136 20";
			
			bitmap = "Add-Ons/Client_BugMeNot/Ignore";
			text = "";   //For whatever strange reason, the text defaults to "Button".
			
			command = "BMN_ignoreSelected();";
		};
		
		new GuiSwatchCtrl()
		{
			position = "160 32";
			minExtent = "2 2"; //The default is (8, 2), causing the swatch to jump to 8 pixels wide.
			extent = "2 106";
			
			color = "0 0 0 128";
		};
		
		//Upper-right quadrant goes here
		
		new GuiSwatchCtrl()
		{
			position = "162 92";
			extent = "122 2";
			
			color = "0 0 0 128";
		};
		
		new GuiTextCtrl()
		{
			position = "188 95";
			extent = "100 12";
			
			text = "Ticket Controls";
		};
		
		new GuiBitmapButtonCtrl(BMN_RaiseButton)
		{
			position = "166 114";
			extent = "35 20";
			
			bitmap = "Add-Ons/Client_BugMeNot/Raise";
			text = "";
			
			command = "BMN_ticketRaiseSelected();";
		};
		
		new GuiBitmapButtonCtrl(BMN_LowerButton)
		{
			position = "205 114";
			extent = "35 20";
			
			bitmap = "Add-Ons/Client_BugMeNot/Lower";
			text = "";
			
			command = "BMN_ticketLowerSelected();";
		};
		
		new GuiBitmapButtonCtrl(BMN_ClearButton)
		{
			position = "244 114";
			extent = "35 20";
			
			bitmap = "Add-Ons/Client_BugMeNot/Clear";
			text = "";
			
			command = "BMN_ticketClearSelected();";
		};
		
		new GuiSwatchCtrl()
		{
			position = "20 140";
			extent = "260 240";
			
			color = "255 255 255 128";
		};
		
		new GuiScrollCtrl()
		{
			position = "20 140";
			extent = "260 240";
			
			profile = "ColorScrollProfile";
			
			hScrollBar = "alwaysOff";
			
			new GuiTextListCtrl(BMN_PlayerList)
			{
				command = "BMN_updateControlButtons();";
				
				position = "0 0";
				extent = "260 240";
				
				columns = "0 220";
			};
		};
	};
};

new GuiBitmapButtonCtrl(BMN_NPLButton)
{
	position = "405 33";
	extent = "76 21";
	
	bitmap = "base/client/ui/button1";
	profile = "BlockButtonProfile";
	text = "Bug-Me-Not";
	
	command = "toggleBugMeNotGUI(1);";
};
NPL_Window.add(BMN_NPLButton);



// ._________________________.
// |   __    _   .__   .____ |
// |  /  \  / \  |  \  |     |
// | {     {   } |   } |__   |
// | {     {   } |   } |     |
// |  \__/  \_/  |__/  |____ |
// |_________________________|

BMN_BuildTrustAction.add("Allow", 0);
BMN_BuildTrustAction.add("Filter", 1);
BMN_BuildTrustAction.add("Reject", 2);

BMN_FullTrustAction.add("Allow", 0);
BMN_FullTrustAction.add("Filter", 1);
BMN_FullTrustAction.add("Reject", 2);

BMN_MinigameAction.add("Allow", 0);
BMN_MinigameAction.add("Filter", 1);
BMN_MinigameAction.add("Reject", 2);

function BugMeNotGUI::onWake(%this)
{
	BMN_BuildTrustAction.setText($BMN::filterTypeBuild);
	BMN_FullTrustAction.setText($BMN::filterTypeFull);
	BMN_MinigameAction.setText($BMN::filterTypeMinigame);
	%this.visible = 1;
	BMN_updatePlayerList();
	if(BMN_PlayerList.getSelectedID() == -1)
	{
		BMN_IgnoreButton.setActive(0);
		BMN_RaiseButton.setActive(0);
		BMN_LowerButton.setActive(0);
		BMN_ClearButton.setActive(0);
	}
}

function BugMeNotGUI::onSleep(%this)
{
	%this.visible = 0;
}

package bugMeNot
{
	function clientcmdChatMessage(%cl, %a, %b, %full, %prefix, %name, %suffix, %msg)
	{
		while((%temp = stripMLControlChars(%name)) !$= %name)
			%name = %temp;
		if(BMN_ignoring(%name))
		{
			%blid = $BMN_blidOf[%name];
			echo(%name@" ("@%blid@")");
			if(%blid == getNumKeyID() || %blid == 999999)
			{
				Parent::clientcmdChatMessage(%cl, %a, %b, %full, %prefix, %name, %suffix, %msg);
				return;
			}
			if(!$BMN:dontIgnore[%blid])
				return;
			else
			{
				while((%temp = stripMLControlChars(%name)) !$= %name)
					%name = %temp;
				%name = "<color:999900>"@%name;
				%full = "\c7"@%prefix@%name@"\c7"@%suffix@"<color:F00000>\c6: "@%msg;
				//I should technically make this use the format at the start of the %full variable, but very few chatmods actually include or change it.
			}
		}
		Parent::clientcmdChatMessage(%cl, %a, %b, %full, %prefix, %name, %suffix, %msg);
	}
	
	function clientcmdTrustInvite(%name, %bl_id, %level)
	{
		Parent::clientcmdTrustInvite(%name, %bl_id, %level);
		%blid = %bl_id + 0;
		if(%level >= 2)
			%trust = "Full";
		else
			%trust = "Build";
		BMN_record("Trust invite from \""@%name@"\" ("@%blid@") for "@%trust@" trust level.");
		if(!BMN_checkBypass(%blid, %trust))
			TrustInviteGui.clickReject();
	}
	
	function clientcmdMinigameInvite(%minigameName, %creatorName, %creatorBL_ID, %minigame)
	{
		Parent::clientcmdMinigameInvite(%minigameName, %creatorName, %creatorBL_ID, %minigame);
		%blid = %creatorBL_ID + 0;
		BMN_record("Minigame invite from \""@%creatorName@"\" ("@%creatorBL_ID@").");
		if(!BMN_checkBypass(%blid, "Minigame"))
			MinigameInviteGui.clickReject();
	}
	
	function secureClientCmd_ClientDrop(%name, %obj)
	{
		if(BMN_PlayerList.getSelectedID() == %obj)
			%update = 1;
		$BMN_dontIgnore[$BMN_blidOf[%name]] = 0;
		BMN_PlayerList.removeRowByID(%obj);
		Parent::secureClientCmd_ClientDrop(%name, %obj);
		if(%update)
			BMN_updateControlButtons();
	}
	
	function secureClientCmd_ClientJoin(%name, %obj, %bl_id, %a, %b, %admin, %sa)
	{
		//One would think this function would only be called when a client joins.
		//However, it's also used to tranfer the player list immediately on joining, so I can use it here.
		if(%admin)
			$BMN:dontIgnore[%bl_id] = 1;   //Even if you hate them, it's a really bad idea to ignore admins.
		Parent::secureClientCmd_ClientJoin(%name, %obj, %bl_id, %a, %b, %admin, %sa);
		BMN_PlayerList.addRow(%obj, %name TAB $BMN::bypassTickets[%bl_id] + 0 TAB %obj);
		$BMN_blidOf[%name] = %bl_id;
	}
	
	function disconnect(%bool)
	{
		BMN_PlayerList.clear();
		BMN_IgnoreButton.setActive(0);
		parent::disconnect(%bool);
		deleteVariables("$BMN:dontIgnore*");
	}
};
activatePackage("bugMeNot");

function BMN_checkBypass(%blid, %type)
{
	if($BMN::filterType[%type] $= "Allow")
		return 1;
	else if($BMN::filterType[%type] $= "Reject")
		return 0;
	if($BMN::bypassTickets[%blid] > 0)
	{
		$BMN::bypassTickets[%blid] -= 1;
		export("$BMN::*", "config/client/BugMeNot.cs");
		BMN_updatePlayerList();
		return 1;
	}
	else
		return 0;
}

function BMN_ignoreSelected()
{
	%list = BMN_PlayerList.getID();
	if((%id = %list.getSelectedID()) == -1)
		return;
	%name = getField(%list.getRowTextByID(%id), 0);
	$BMN::ignore[$BMN_blidOf[%name]] = !$BMN::ignore[$BMN_blidOf[%name]];
	BMN_updateControlButtons();
	export("$BMN::*", "config/client/BugMeNot.cs");
}

function BMN_ignoring(%name)
{
	%blid = $BMN_blidOf[%name];
	if($BMN::ignore[%blid])
		return 1;
	return 0;
}

function BMN_record(%text)
{
	if($BMN::Debugging)
		echo(%text);
}

function BMN_ticketRaiseSelected()
{
	%list = BMN_PlayerList.getID();
	if((%id = %list.getSelectedID()) == -1)
		return;
	%name = getField(%list.getRowTextByID(%id), 0);
	%blid = $BMN_blidOf[%name];
	%tickets = $BMN::bypassTickets[%blid] + 1;
	if(%tickets > 100)
		%tickets = 100;
	$BMN::bypassTickets[%blid] = %tickets;
	BMN_updatePlayerList();
	export("$BMN::*", "config/client/BugMeNot.cs");
}

function BMN_ticketLowerSelected()
{
	%list = BMN_PlayerList.getID();
	if((%id = %list.getSelectedID()) == -1)
		return;
	%name = getField(%list.getRowTextByID(%id), 0);
	%blid = $BMN_blidOf[%name];
	%tickets = $BMN::bypassTickets[%blid] - 1;
	if(%tickets < 0)
		%tickets = 0;
	$BMN::bypassTickets[%blid] = %tickets;
	BMN_updatePlayerList();
	export("$BMN::*", "config/client/BugMeNot.cs");
}

function BMN_ticketClearSelected()
{
	%list = BMN_PlayerList.getID();
	if((%id = %list.getSelectedID()) == -1)
		return;
	%name = getField(%list.getRowTextByID(%id), 0);
	$BMN::bypassTickets[$BMN_blidOf[%name]] = 0;
	BMN_updatePlayerList();
	export("$BMN::*", "config/client/BugMeNot.cs");
}

function BMN_updateAction(%type)
{
	switch$(%type)
	{
		case "Build":
			%this = BMN_BuildTrustAction.getID();
		case "Full":
			%this = BMN_FullTrustAction.getID();
		case "Minigame":
			%this = BMN_MinigameAction.getID();
	}
	%text = %this.getTextByID(%this.getSelected());
	$BMN::filterType[%type] = %text;
	export("$BMN::*", "config/client/BugMeNot.cs");
}

function BMN_updateControlButtons()
{
	%list = BMN_PlayerList.getID();
	if((%id = %list.getSelectedID()) == -1)
	{
		BMN_IgnoreButton.setActive(0);
		BMN_RaiseButton.setActive(0);
		BMN_LowerButton.setActive(0);
		BMN_ClearButton.setActive(0);
	}
	else
	{
		BMN_IgnoreButton.setActive(1);
		BMN_RaiseButton.setActive(1);
		BMN_LowerButton.setActive(1);
		BMN_ClearButton.setActive(1);
		%name = getField(%list.getRowTextByID(%id), 0);
		if(BMN_ignoring(%name))
			BMN_IgnoreButton.setBitmap("Add-Ons/Client_BugMeNot/Unignore");
		else
			BMN_IgnoreButton.setBitmap("Add-Ons/Client_BugMeNot/Ignore");
	}
}

function BMN_updatePlayerList()
{
	%list = BMN_PlayerList.getID();
	for(%i=0;%i<%list.rowCount();%i++)
	{
		%text = %list.getRowText(%i);
		%name = getField(%text, 0);
		%blid = $BMN_blidOf[%name];
		%tickets = $BMN::bypassTickets[%blid];
		%list.setRowByID(getField(%text, 2), %name TAB %tickets + 0 TAB getField(%text, 2));
	}
}

if(!$BMN_boundKeybind)
{
	$BMN_boundKeybind = 1;
	$remapDivision[$remapCount] = "Bug-Me-Not";
	$remapName[$remapCount] = "Toggle Bug-Me-Not GUI";
	$remapCmd[$remapCount] = "toggleBugMeNotGUI";
	$remapCount++;
}

function toggleBugMeNotGUI(%tog)
{
	if(%tog)
		if(BugMeNotGUI.visible)
			Canvas.popDialog(BugMeNotGUI);
		else
			Canvas.pushDialog(BugMeNotGUI);
}

if(isFile("config/client/BugMeNot.cs"))
	exec("config/client/BugMeNot.cs");
if($BMN::filterTypeBuild $= "")
	$BMN::filterTypeBuild = "Filter";
if($BMN::filterTypeFull $= "")
	$BMN::filterTypeFull = "Filter";
if($BMN::filterTypeMinigame $= "")
	$BMN::filterTypeMinigame = "Filter";
